// This file is generated by kconfig_compiler_kf6 from nighttimesettings.kcfg.
// All changes you do to this file will be lost.
#ifndef NIGHTTIMESETTINGS_H
#define NIGHTTIMESETTINGS_H

#include <qglobal.h>
#include <kconfigskeleton.h>
#include <QCoreApplication>
#include <QDebug>

class NightTimeSettings : public KConfigSkeleton
{
  Q_OBJECT
  public:
    enum Source { AutomaticLocation, ManualLocation, ManualTimes };
    Q_ENUM(Source)

    NightTimeSettings( QObject *parent = nullptr );
    ~NightTimeSettings() override;

    /**
      Set Source
    */
    void setSource( int v )
    {
      if (v != mSource && !isSourceImmutable()) {
        mSource = v;
        Q_EMIT SourceChanged();
      }
    }

    Q_PROPERTY(int source READ source WRITE setSource NOTIFY SourceChanged)
    Q_PROPERTY(bool isSourceImmutable READ isSourceImmutable CONSTANT)
    /**
      Get Source
    */
    int source() const
    {
      return mSource;
    }

    /**
      Is Source Immutable
    */
    bool isSourceImmutable() const
    {
      return isImmutable( QStringLiteral( "Source" ) );
    }

    /**
      Set Latitude
    */
    void setLatitude( double v )
    {
      if (v != mLatitude && !isLatitudeImmutable()) {
        mLatitude = v;
        Q_EMIT LatitudeChanged();
      }
    }

    Q_PROPERTY(double latitude READ latitude WRITE setLatitude NOTIFY LatitudeChanged)
    Q_PROPERTY(bool isLatitudeImmutable READ isLatitudeImmutable CONSTANT)
    /**
      Get Latitude
    */
    double latitude() const
    {
      return mLatitude;
    }

    /**
      Is Latitude Immutable
    */
    bool isLatitudeImmutable() const
    {
      return isImmutable( QStringLiteral( "Latitude" ) );
    }

    /**
      Set Longitude
    */
    void setLongitude( double v )
    {
      if (v != mLongitude && !isLongitudeImmutable()) {
        mLongitude = v;
        Q_EMIT LongitudeChanged();
      }
    }

    Q_PROPERTY(double longitude READ longitude WRITE setLongitude NOTIFY LongitudeChanged)
    Q_PROPERTY(bool isLongitudeImmutable READ isLongitudeImmutable CONSTANT)
    /**
      Get Longitude
    */
    double longitude() const
    {
      return mLongitude;
    }

    /**
      Is Longitude Immutable
    */
    bool isLongitudeImmutable() const
    {
      return isImmutable( QStringLiteral( "Longitude" ) );
    }

    /**
      Set SunsetStart
    */
    void setSunsetStart( const QString & v )
    {
      if (v != mSunsetStart && !isSunsetStartImmutable()) {
        mSunsetStart = v;
        Q_EMIT SunsetStartChanged();
      }
    }

    Q_PROPERTY(QString sunsetStart READ sunsetStart WRITE setSunsetStart NOTIFY SunsetStartChanged)
    Q_PROPERTY(bool isSunsetStartImmutable READ isSunsetStartImmutable CONSTANT)
    /**
      Get SunsetStart
    */
    QString sunsetStart() const
    {
      return mSunsetStart;
    }

    /**
      Is SunsetStart Immutable
    */
    bool isSunsetStartImmutable() const
    {
      return isImmutable( QStringLiteral( "SunsetStart" ) );
    }

    /**
      Set SunriseStart
    */
    void setSunriseStart( const QString & v )
    {
      if (v != mSunriseStart && !isSunriseStartImmutable()) {
        mSunriseStart = v;
        Q_EMIT SunriseStartChanged();
      }
    }

    Q_PROPERTY(QString sunriseStart READ sunriseStart WRITE setSunriseStart NOTIFY SunriseStartChanged)
    Q_PROPERTY(bool isSunriseStartImmutable READ isSunriseStartImmutable CONSTANT)
    /**
      Get SunriseStart
    */
    QString sunriseStart() const
    {
      return mSunriseStart;
    }

    /**
      Is SunriseStart Immutable
    */
    bool isSunriseStartImmutable() const
    {
      return isImmutable( QStringLiteral( "SunriseStart" ) );
    }

    /**
      Set TransitionDuration
    */
    void setTransitionDuration( uint v )
    {
      if (v != mTransitionDuration && !isTransitionDurationImmutable()) {
        mTransitionDuration = v;
        Q_EMIT TransitionDurationChanged();
      }
    }

    Q_PROPERTY(uint transitionDuration READ transitionDuration WRITE setTransitionDuration NOTIFY TransitionDurationChanged)
    Q_PROPERTY(bool isTransitionDurationImmutable READ isTransitionDurationImmutable CONSTANT)
    /**
      Get TransitionDuration
    */
    uint transitionDuration() const
    {
      return mTransitionDuration;
    }

    /**
      Is TransitionDuration Immutable
    */
    bool isTransitionDurationImmutable() const
    {
      return isImmutable( QStringLiteral( "TransitionDuration" ) );
    }


    enum {
      signalSourceChanged = 1,
      signalLatitudeChanged = 2,
      signalLongitudeChanged = 3,
      signalSunsetStartChanged = 4,
      signalSunriseStartChanged = 5,
      signalTransitionDurationChanged = 6
    };

  Q_SIGNALS:
    void SourceChanged();

    void LatitudeChanged();

    void LongitudeChanged();

    void SunsetStartChanged();

    void SunriseStartChanged();

    void TransitionDurationChanged();

  private:
    void itemChanged(quint64 signalFlag);

  protected:

    // General
    int mSource;

    // ManualLocation
    double mLatitude;
    double mLongitude;

    // ManualTimes
    QString mSunsetStart;
    QString mSunriseStart;
    uint mTransitionDuration;

  private:
};

#endif

